//------------------------------------------------------------------------------
// Guitar Practice
//------------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		The guitar practice constant definitions.
//
//	Description:   	This unit contains the classes used by
//                 the guitar practice system
//
// Created:		FeMann
// Date:			30.08.2009
//
// (c) Copyright by FeMann.
// All rights reserved.
//
//

unit CGPConst;

interface

const

// Changes: Bugfix in last open files managment

//------------------------------------------------------------------------------
// Version and Build constants
//------------------------------------------------------------------------------

	GP_TITLE: string = 'Guitar Practice';
	GP_VERSION: string = '2.0';
	GP_BUILD: string = '20100318';
	GP_AUTHOR: string = 'FeMann';
	GP_HOME: string = 'https://sourceforge.net/projects/guitarpractice/';
	GP_EMAIL: string = 'femann@freenet.de';

//------------------------------------------------------------------------------
// Options file definitions
//------------------------------------------------------------------------------

	GP_OPTIONFILE_FILENAME: string = 'gpoptions.ini';
	GP_OPTIONFILE_SECTION_GENERAL: string = 'GENERAL';
	GP_OPTIONFILE_SECTION_ENCODERDEFAULTS: string = 'ENCODERDEFAULTS';
	GP_OPTIONFILE_VALUE_LEFT: string = 'LEFT';
	GP_OPTIONFILE_VALUE_TOP: string = 'TOP';
	GP_OPTIONFILE_VALUE_WIDTH: string = 'WIDTH';
	GP_OPTIONFILE_VALUE_HEIGHT: string = 'HEIGHT';
	GP_OPTIONFILE_VALUE_LASTOPENFILENAME: string = 'LASTOPENFILENAME';
	GP_OPTIONFILE_VALUE_LANGUAGE: string = 'LANGUAGE';
	GP_OPTIONFILE_VALUE_LASTOPENFILES: string = 'LASTOPENFILES';
	GP_OPTIONFILE_VALUE_CURRENTMP3DIR: string = 'CURRENTMP3DIR';
	GP_OPTIONFILE_VALUE_CURRENTGPFDIR: string = 'CURRENTGPFDIR';
	GP_OPTIONFILE_VALUE_ENCODER: string = 'ENCODER';
	GP_OPTIONFILE_VALUE_ENCODERCOMMANDLINE: string = 'ENCODERCOMMANDLINE';
	GP_OPTIONFILE_VALUE_ENCODEROUTPUTDIRECTORY: string = 'ENCODEROUTPUTDIRECTORY';
	GP_OPTIONFILE_VALUE_ENCODERDEFAULT: string = 'ENCODERDEFAULT';
	GP_OPTIONFILE_VALUE_KEEPFILEHISTORY: string = 'KEEPFILEHISTORY';
	GP_OPTIONFILE_DEFAULT_LEFT: integer = -1;
	GP_OPTIONFILE_DEFAULT_TOP: integer = -1;
	GP_OPTIONFILE_DEFAULT_WIDTH: integer = -1;
	GP_OPTIONFILE_DEFAULT_HEIGHT: integer = -1;
	GP_OPTIONFILE_DEFAULT_LASTOPENFILENAME: string = '';
	GP_OPTIONFILE_DEFAULT_LANGUAGE: string = '';
	GP_OPTIONFILE_DEFAULT_LASTOPENFILES: string = '';
	GP_OPTIONFILE_DEFAULT_CURRENTMP3DIR: string = '';
	GP_OPTIONFILE_DEFAULT_CURRENTGPFDIR: string = '';
	GP_OPTIONFILE_DEFAULT_ENCODER: string = '';
	GP_OPTIONFILE_DEFAULT_ENCODERCOMMANDLINE: string = '';
	GP_OPTIONFILE_DEFAULT_ENCODEROUTPUTDIRECTORY: string = '';
	GP_OPTIONFILE_DEFAULT_KEEPFILEHISTORY: integer = 25;

//------------------------------------------------------------------------------
// Guitar practice file definitions
//------------------------------------------------------------------------------

	GP_FILE_SECTION_GENERAL: string = 'GENERAL';
	GP_FILE_SECTION_SOUNDSEGMENTS: string = 'SOUNDSEGMENTS';
	GP_FILE_VALUE_TITLE: string = 'TITLE';
	GP_FILE_VALUE_SOUNDSEGMENT: string = 'SOUNDSEGMENT';
   GP_FILE_VALUE_EQSETTINGS: string = 'EQSETTINGS';
	GP_FILE_DEFAULT_TITLE: string = '';
	GP_FILE_DEFAULT_SOUNDSEGMENT: string = '';
   GP_FILE_DEFAULT_EQSETTINGS: string = '';

//------------------------------------------------------------------------------
// Command line params
//------------------------------------------------------------------------------

	GP_COMMAND_PARAM_GPFILE: string = '-gpfile';
	GP_COMMAND_PARAM_PLAY: string = '-play';
   GP_COMMAND_PARAM_TRANSLATE: string = '-translate';

//------------------------------------------------------------------------------
// Translateable variables
//------------------------------------------------------------------------------

	GP_VARIABLE_SONGTITLE: string = 'SONG.TITLE';
	GP_VARIABLE_TITLE_DESCRIPTION: string = 'TITLE.DESCRIPTION';
   GP_VARIABLE_TITLE_FILENAME: string = 'TITLE.FILENAME';
	GP_MESSAGE_FILE_NEW: string = 'MESSAGE.FILENEW';
	GP_MESSAGE_FILE_EXPORT_COMPLETE: string = 'MESSAGE.FILEEXPORTCOMPLETE';
	GP_FORM_CAPTION_OPTIONS: string = 'FORM.CAPTION.OPTIONS';
	GP_VARIABLE_SONGTITLE_DEFAULT: string = '(no title)';
	GP_VARIABLE_TITLE_DESCRIPTION_DEFAULT: string = 'Description';
	GP_VARIABLE_TITLE_FILENAME_DEFAULT: string = 'Filename';
	GP_MESSAGE_FILE_NEW_DEFAULT: string = 'Do you want to start a new guitar practice file?';
	GP_MESSAGE_FILE_EXPORT_COMPLETE_DEFAULT: string = 'Export complete';
	GP_FORM_CAPTION_OPTIONS_DEFAULT: string = 'Options';

//------------------------------------------------------------------------------
// Encoder default constant definitions
//------------------------------------------------------------------------------

	GP_ENCODER_DEFAULT_LAME_EXE_NAME: string = 'lame.exe';
	GP_ENCODER_DEFAULT_LAME_COMMAND_LINE: string = '--alt-preset standard - %OUTPUTFILENAME%.mp3';
	GP_ENCODER_DEFAULT_OGGVORBIS_EXE_NAME: string = 'oggenc2.exe';
	GP_ENCODER_DEFAULT_OGGVORBIS_COMMAND_LINE: string = '-o %OUTPUTFILENAME%.ogg -';

//------------------------------------------------------------------------------
// Other constant definitions
//------------------------------------------------------------------------------

	GP_GUITARPRACTICEFILE_EXTENSION: string = 'gpf';
	GP_GUITARPRACTICEFILE_FILTER: string = 'Guitar Practice File (*.gpf)|*.gpf';
	GP_SOUNDFILE_FILTER: string = 'Sound files|*.mp1;*.mp2;*.mp3;*.ogg;*.wav;*.aiff';
	GP_MAX_OPENFILE_HISTORY: integer = 25;

implementation

end.
