//
// Unit:			CCommandLine.pas
// Description:	This unit implements the command line classes
// Autor:          FeMann
// Date:			11.06.2004
//

unit CCommandLine;

interface

uses
	Classes, SysUtils;

type

   // The command line token
   //
   CCommandLineParam = class
   	// Private declarations
       private
			m_name: string;
           m_value: string;
       // Public declarations
       public
       	constructor Create;
           destructor Destroy; override;
       public
           property Name: string read m_name write m_name;
           property Value: string read m_value write m_value;
   end;

	// The command line manager class
   //
   CCommandLineManager = class
   	// Private declarations
       private
           m_params: TList;
       private
       	function getParamValue(name: string): string;
       private
       	procedure clearParams;
           procedure addParam(const name: string; const value: string);
       // Public declarations
		public
       	constructor Create;
           destructor Destroy; override;
       public
       	function Parse: boolean;
           function ParamExists(name: string): boolean;
       public
       	property ParamValue[name: string]: string read getParamValue;
   end;

implementation

//------------------------------------------------------------------------------
// Implementation of CCommandLineParam.pas
//------------------------------------------------------------------------------
{$I CCommandLineParam.pas}

//------------------------------------------------------------------------------
// Implementation of CCommandLineManager.pas
//------------------------------------------------------------------------------
{$I CCommandLineManager.pas}

end.
