//------------------------------------------------------------------------------
// File classes
//------------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		Implementation of CDelimitedStringList.
//
//	Description:  	This unit implements the delimited string list
//
//
//
// Author(s):		FeMann
// Created:		10.10.2009
//
// (c) Copyright by FeMann
// All rights reserved.
//
//

//------------------------------------------------------------------------------
// Constructor and Destructor
//------------------------------------------------------------------------------

// Constructor
//
constructor CDelimitedStringList.Create;
begin
	inherited;

   // Init the delimiter char
   Delimiter := ';'
end;

// Destructor
//
destructor CDelimitedStringList.Destroy;
begin
	try
   finally
		inherited;
   end;
end;

//------------------------------------------------------------------------------
// Public declarations
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Private declarations
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Property declarations
//------------------------------------------------------------------------------

// Get the list as delimited text
//
function CDelimitedStringList.getDelimitedText: string;
var
	i: integer;
begin
	// Init result
   result := '';

   // Validate items
   if (Count <= 0) then
   	exit;

   // Build delimiter string
   for i := 0 to Count - 1 do
   	result := result + Strings[i] + Delimiter;
end;

// Set the list as delimited text
//
procedure CDelimitedStringList.setDelimitedText(val: string);
var
	c: char;
   s: string;
   i: integer;
begin
	// Clear the list
   Clear;

   // Validate items
   if (val = '') or (val = Delimiter) then
   	exit;

   // Init
   s := '';

   // Parse value
   for i := 1 to Length(val) do
   begin
   	// Get the character
       c := val[i];

       // Compare delimiter
       if (c = Delimiter) then
       begin
       	// Add to list
           if (s <> '') then
           	Add(s);

           // Reset
           s := '';
       end
       // Add to string
       else if (c <> Delimiter) then
       	s := s + c
   end;

   // Check for last item
   if (s <> '') and (s <> Delimiter) then
   	Add(s);
end;
