//------------------------------------------------------------------------------
// File classes
//------------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		Implementation of CLastOpenFile.
//
//	Description:  	This unit implements the last open file
//
//
//
// Author(s):		FeMann
// Created:		04.10.2009
//
// (c) Copyright by FeMann
// All rights reserved.
//
//

//------------------------------------------------------------------------------
// Constructor and Destructor
//------------------------------------------------------------------------------

// Constructor
//
constructor CLastOpenFile.Create(myFiles: CLastOpenFiles);
begin
	inherited Create;

   // Set manager backward reference
	m_files := myFiles;

	// Reset the file
	Reset;
end;

// Destructor
//
destructor CLastOpenFile.Destroy;
begin
	try
   	// Reset manager reference
       m_files := nil;
   finally
		inherited;
   end;
end;

//------------------------------------------------------------------------------
// Public declarations
//------------------------------------------------------------------------------

// Reset the file
//
procedure CLastOpenFile.Reset;
begin
	m_fileName := '';
end;

//------------------------------------------------------------------------------
// Private declarations
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Property declarations
//------------------------------------------------------------------------------

// Determine if file exists
//
function CLastOpenFile.getExists: boolean;
begin
	result :=  (m_fileName <> '') and FileExists(m_fileName);
end;
