//--------------------------------------------------------------------------
// CLanguages
//--------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		Implementation of CTranslateDefinitionBase.
//
//	Description:  	This unit implements the language form registerer class
//
//
// Author(s):		FeMann
// Created:		02.09.2009
//
// (c) Copyright by FeMann
// All rights reserved.
//
//


//------------------------------------------------------------------------------
// Constructor and Destructor
//------------------------------------------------------------------------------

// Constructor
//
constructor CTranslateDefinitionBase.Create(myManager: CLanguageManager);
begin
	inherited Create;

   // Set manager backward reference
	m_manager := myManager;
end;

// Destructor
//
destructor CTranslateDefinitionBase.Destroy;
begin
	try
   	// Reset manager reference
       m_manager := nil;
   finally
		inherited;
   end;
end;

//------------------------------------------------------------------------------
// Public declarations
//------------------------------------------------------------------------------

// Register the given form
//
procedure CTranslateDefinitionBase.RegisterForm(formClass: CTranslatableFormClass; formName: string);
begin
	// Register the form
	m_manager.TranslateableForms.RegisterForm(formClass,formName);
end;

// Register the variable
//
procedure CTranslateDefinitionBase.RegisterVariable(name: string; text: string);
begin
	m_manager.Variables.AddVariable(name,text);
end;

//------------------------------------------------------------------------------
// Private declarations
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Property declarations
//------------------------------------------------------------------------------

