//--------------------------------------------------------------------------
// CLanguages
//--------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		Implementation of CTranslateForm.
//
//	Description:  	This unit implements the translatable form class
//
//
// Author(s):		FeMann
// Created:		02.09.2009
//
// (c) Copyright by FeMann
// All rights reserved.
//
//

//------------------------------------------------------------------------------
// Constructor and Destructor
//------------------------------------------------------------------------------

// Constructor
//
constructor CTranslateForm.Create(myForms: CTranslateForms);
begin
	inherited Create;

	// Set backward reference to forms
	m_forms := myForms;

	// Reset the form
	Reset;
end;

// Destructor
//
destructor CTranslateForm.Destroy;
begin
	try
		// Free the controls
		freeControls;

		// Reset the forms reference
		m_forms := nil;
	finally
   	inherited;
   end;
end;

//------------------------------------------------------------------------------
// Public methods
//------------------------------------------------------------------------------

// Reset the form
//
procedure CTranslateForm.Reset;
begin
	// Reset the form name
	m_formName := '';

	// Free the controls
	freeControls;
end;

//------------------------------------------------------------------------------
// Private methods
//------------------------------------------------------------------------------

// Reset the controls
//
procedure CTranslateForm.freeControls;
begin
	// Free the controls
	if Assigned(m_controls) then
		FreeAndNil(m_controls);
end;

//------------------------------------------------------------------------------
// Property methods
//------------------------------------------------------------------------------

// Get the controls
//
function CTranslateForm.getControls: CTranslateFormControls;
begin
	// Create controls on demand
	if not Assigned(m_controls) then
		m_controls := CTranslateFormControls.Create(self);

	// Return instance
	result := m_controls;
end;
