//--------------------------------------------------------------------------
// CLanguages
//--------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		Implementation of CTranslateFormControl.
//
//	Description:  	This unit implements the translatable form control class
//
//
// Author(s):		FeMann
// Created:		02.09.2009
//
// (c) Copyright by FeMann
// All rights reserved.
//
//

//------------------------------------------------------------------------------
// Constructor and Destructor
//------------------------------------------------------------------------------

// Constructor
//
constructor CTranslateFormControl.Create(myControls: CTranslateFormControls);
begin
	inherited Create;

	// Set backward reference to controls
	m_formControls := myControls;

	// Reset the control
	Reset;
end;

// Destructor
//
destructor CTranslateFormControl.Destroy;
begin
	try
		// Reset the controls reference
		m_formControls := nil;
	finally
   	inherited;
   end;
end;

//------------------------------------------------------------------------------
// Public methods
//------------------------------------------------------------------------------

// Reset the control
//
procedure CTranslateFormControl.Reset;
begin
	m_controlName := '';
	m_caption := '';
end;

//------------------------------------------------------------------------------
// Private methods
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Property methods
//------------------------------------------------------------------------------
