//--------------------------------------------------------------------------
// CLanguages
//--------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		Implementation of CTranslateVariable.
//
//	Description:  	This unit implements the translatable variable  class
//
//
// Author(s):		FeMann
// Created:		02.09.2009
//
// (c) Copyright by FeMann
// All rights reserved.
//
//

//------------------------------------------------------------------------------
// Constructor and Destructor
//------------------------------------------------------------------------------

// Constructor
//
constructor CTranslateVariable.Create(myVariables: CTranslateVariables);
begin
	inherited Create;

	// Set backward reference to variables
	m_variables := myVariables;

	// Reset the variable
	Reset;
end;

// Destructor
//
destructor CTranslateVariable.Destroy;
begin
	try
		// Reset the variables reference
		m_variables := nil;
	finally
   	inherited;
   end;
end;

//------------------------------------------------------------------------------
// Public methods
//------------------------------------------------------------------------------

// Reset the control
//
procedure CTranslateVariable.Reset;
begin
	m_name := '';
	m_text := '';
	m_originalText := '';
end;

// Undo the control changes
//
procedure CTranslateVariable.UndoChanges;
begin
	// Restore the original properties
   Text := OriginalText;
end;

//------------------------------------------------------------------------------
// Private methods
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Property methods
//------------------------------------------------------------------------------

// Get the text
//
function CTranslateVariable.getText: string;
begin
	result := m_text;
end;

// Set the text
//
procedure CTranslateVariable.setText(val: string);
begin
	// Set the text
	m_text := val;

	// Set the original text
	if (OriginalText = '') then
       OriginalText := val;
end;


