//--------------------------------------------------------------------------
// CLanguages
//--------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		Implementation of CTranslation.
//
//	Description:  	This unit implements the translation class
//
//
// Author(s):		FeMann
// Created:		02.09.2009
//
// (c) Copyright by FeMann
// All rights reserved.
//
//

//------------------------------------------------------------------------------
// Constructor and Destructor
//------------------------------------------------------------------------------

// Constructor
//
constructor CTranslation.Create(myTranslations: CTranslations);
begin
	inherited Create;

	// Set backward reference to translations
	m_translations := myTranslations;
end;

// Destructor
//
destructor CTranslation.Destroy;
begin
	try
		// Reset the translations reference
		m_translations := nil;
	finally
   	inherited;
   end;
end;

//------------------------------------------------------------------------------
// Public methods
//------------------------------------------------------------------------------

// Reset the control
//
procedure CTranslation.Reset;
begin
	m_fileName := '';
end;

//------------------------------------------------------------------------------
// Private methods
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Property methods
//------------------------------------------------------------------------------

// Get the control name
//
function CTranslation.getName: string;
var
	fName: string;
   posExtension: integer;
begin
	// Get the filename
   fName := ExtractFileName(m_fileName);

   // Get the extension position
   posExtension := Pos(CONST_LANGUAGEFILE_EXTENSION,fName);

	// Get name from file name
	result := Copy(fName,1,posExtension - 1);
end;
