//------------------------------------------------------------------------------
// Guitar Practice
//------------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		The guitar practice language definition.
//
//	Description:   	This unit contains the classes used by for the
//                 definition of the translatable forms and variables
//
// Created:		FeMann
// Date:			26.09.2009
//
// (c) Copyright by FeMann.
// All rights reserved.
//
//

unit CGuitarPracticeLanguageDefinitions;

interface

uses
	CLanguages;

type
	// The guitar practice translation definition
	//
	CGuitarPracticeTranslateDefinition = class(CTranslateDefinitionBase)
		// Public declarations
		public
			procedure RegisterForms; override;
			procedure RegisterVariables; override;
	end;

implementation

uses
	UFrmGuitarPracticeMain, UFrmGuitarPracticeProgress, UFrmGuitarPracticeOptions,
	CGPConst;

// Register the forms
//
procedure CGuitarPracticeTranslateDefinition.RegisterForms;
begin
	RegisterForm(TFrmGuitarPractice,'GuitarPractice main form');
	RegisterForm(TFrmGuitarPracticeProgress,'GuitarPractice progress form');
	RegisterForm(TFrmGuitarPracticeOptions,'GuitarPractice options form');
end;

// Register the variables
//
procedure CGuitarPracticeTranslateDefinition.RegisterVariables;
begin
	RegisterVariable(GP_VARIABLE_SONGTITLE,GP_VARIABLE_SONGTITLE_DEFAULT);
   RegisterVariable(GP_VARIABLE_TITLE_DESCRIPTION,GP_VARIABLE_TITLE_DESCRIPTION_DEFAULT);
   RegisterVariable(GP_VARIABLE_TITLE_FILENAME,GP_VARIABLE_TITLE_FILENAME_DEFAULT);
	RegisterVariable(GP_MESSAGE_FILE_NEW,GP_MESSAGE_FILE_NEW_DEFAULT);
	RegisterVariable(GP_MESSAGE_FILE_EXPORT_COMPLETE,GP_MESSAGE_FILE_EXPORT_COMPLETE_DEFAULT);
	RegisterVariable(GP_FORM_CAPTION_OPTIONS,GP_FORM_CAPTION_OPTIONS_DEFAULT);
end;

end.
