//------------------------------------------------------------------------------
// Guitar Practice
//------------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		The guitar practice main form.
//
//	Description:   	This unit implements the main form of the
//                 guitar practice system
//
// Created:		FeMann
// Date:			30.08.2009
//
// (c) Copyright by FeMann.
// All rights reserved.
//
//

unit UFrmGuitarPracticeMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CGPClasses, ComCtrls, ExtCtrls, Spin, CCommandLine, CFileClasses,
  UFrmGuitarPracticeAbout, UFrmGuitarPracticeOptions, Menus;

type
	// Guitar practice main form
   //
	TFrmGuitarPractice = class(TForm)
    pnlBase: TPanel;
    pnlLeftBase: TPanel;
    pnlRightBase: TPanel;
    grpTitle: TGroupBox;
    lblTitleDescription: TLabel;
    txtTitleDescription: TEdit;
    cmdAddTitle: TButton;
    cmdRemove: TButton;
    lvwTitles: TListView;
    cmdOpen: TButton;
    grpLoop: TGroupBox;
    grpPlay: TGroupBox;
    cmdPlay: TButton;
    cmdRestart: TButton;
    scbPosition: TScrollBar;
    lblCurrentPosition: TLabel;
    lblChannelLength: TLabel;
    lblSlash1: TLabel;
    lblLoopStart: TLabel;
    lblLoopEnd: TLabel;
	 lblLoopMinute: TLabel;
    lblLoopSecond: TLabel;
    spnLoopStartMinute: TSpinEdit;
    spnLoopStartSecond: TSpinEdit;
    spnLoopEndMinute: TSpinEdit;
    spnLoopEndSecond: TSpinEdit;
    chkLoop: TCheckBox;
    grpSettings: TGroupBox;
    cmdSetLoopStart: TButton;
    cmdSetLoopEnd: TButton;
    scbVolume: TScrollBar;
    lblVolume: TLabel;
    cmdResetVolume: TButton;
    lblDisplayVolume: TLabel;
    lblPanning: TLabel;
    scbPanning: TScrollBar;
    cmdResetPanning: TButton;
    lblDisplayPanning: TLabel;
    lblTempo: TLabel;
    scbTempo: TScrollBar;
    cmdResetTempo: TButton;
    lblDisplayTempo: TLabel;
    lblRate: TLabel;
    scbRate: TScrollBar;
    cmdResetRate: TButton;
    lblDisplayRate: TLabel;
    lblPitch: TLabel;
    scbPitch: TScrollBar;
    cmdResetPitch: TButton;
    lblDisplayPitch: TLabel;
    cmdSave: TButton;
    grpMisc: TGroupBox;
    cmdAbout: TButton;
    lblSongTitle: TLabel;
    cmdClear: TButton;
    lblLoopMilli: TLabel;
    spnLoopStartMilli: TSpinEdit;
    spnLoopEndMilli: TSpinEdit;
    cmdChangeLanguage: TButton;
    mnuTitles: TPopupMenu;
    mnuCopyTitle: TMenuItem;
    mnuRemoveTitle: TMenuItem;
    mnuAddTitle: TMenuItem;
    mnuClearTitles: TMenuItem;
    cmdLastOpenFiles: TButton;
    mnuLastOpenFiles: TPopupMenu;
    cmdNew: TButton;
    cmdOpenEQ: TButton;
    grpEQ: TGroupBox;
    cmdCloseEQ: TButton;
    scbBand1: TScrollBar;
    scbBand2: TScrollBar;
	 scbBand3: TScrollBar;
    scbBand4: TScrollBar;
    scbBand5: TScrollBar;
    scbBand6: TScrollBar;
    scbBand7: TScrollBar;
    scbBand8: TScrollBar;
    scbBand9: TScrollBar;
    scbBand10: TScrollBar;
    lblBand1: TLabel;
    lblBand2: TLabel;
    lblBand3: TLabel;
    lblBand4: TLabel;
    lblBand5: TLabel;
    lblBand6: TLabel;
    lblBand7: TLabel;
    lblBand8: TLabel;
    lblBand9: TLabel;
    lblBand10: TLabel;
    cmdResetEQ: TButton;
    mnuSplitter1: TMenuItem;
    mnuExportTitle: TMenuItem;
    mnuExportAllTitles: TMenuItem;
    cmdShowOptions: TButton;
    cmdLoopStartFirst: TButton;
    cmdLoopStartLast: TButton;
    cmdLoopEndFirst: TButton;
    cmdLoopEndLast: TButton;
	 procedure FormCreate(Sender: TObject);
	 procedure FormDestroy(Sender: TObject);
    procedure cmdAddTitleClick(Sender: TObject);
	 procedure cmdRestartClick(Sender: TObject);
    procedure scbPositionChange(Sender: TObject);
    procedure chkLoopClick(Sender: TObject);
    procedure cmdSetLoopStartClick(Sender: TObject);
    procedure cmdSetLoopEndClick(Sender: TObject);
    procedure spnLoopStartMinuteChange(Sender: TObject);
    procedure spnLoopStartSecondChange(Sender: TObject);
    procedure spnLoopEndMinuteChange(Sender: TObject);
    procedure spnLoopEndSecondChange(Sender: TObject);
    procedure cmdResetVolumeClick(Sender: TObject);
    procedure cmdResetPanningClick(Sender: TObject);
    procedure cmdResetTempoClick(Sender: TObject);
    procedure cmdResetRateClick(Sender: TObject);
    procedure cmdResetPitchClick(Sender: TObject);
    procedure scbVolumeChange(Sender: TObject);
    procedure scbPanningChange(Sender: TObject);
    procedure scbTempoChange(Sender: TObject);
    procedure scbRateChange(Sender: TObject);
    procedure scbPitchChange(Sender: TObject);
    procedure cmdPlayClick(Sender: TObject);
	 procedure lvwTitlesEdited(Sender: TObject; Item: TListItem; var S: String);
    procedure lvwTitlesDblClick(Sender: TObject);
    procedure cmdRemoveClick(Sender: TObject);
	 procedure lvwTitlesChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdOpenClick(Sender: TObject);
	 procedure cmdSaveClick(Sender: TObject);
    procedure cmdAboutClick(Sender: TObject);
    procedure cmdClearClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure spnLoopStartMilliChange(Sender: TObject);
    procedure spnLoopEndMilliChange(Sender: TObject);
    procedure cmdChangeLanguageClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure mnuTitlesPopup(Sender: TObject);
    procedure mnuCopyTitleClick(Sender: TObject);
    procedure mnuAddTitleClick(Sender: TObject);
    procedure mnuRemoveTitleClick(Sender: TObject);
    procedure mnuClearTitlesClick(Sender: TObject);
    procedure cmdLastOpenFilesClick(Sender: TObject);
    procedure cmdNewClick(Sender: TObject);
    procedure cmdCloseEQClick(Sender: TObject);
    procedure cmdOpenEQClick(Sender: TObject);
    procedure scbBand1Change(Sender: TObject);
    procedure scbBand2Change(Sender: TObject);
    procedure scbBand3Change(Sender: TObject);
    procedure scbBand4Change(Sender: TObject);
    procedure scbBand5Change(Sender: TObject);
    procedure scbBand6Change(Sender: TObject);
    procedure scbBand7Change(Sender: TObject);
    procedure scbBand8Change(Sender: TObject);
    procedure scbBand9Change(Sender: TObject);
    procedure scbBand10Change(Sender: TObject);
    procedure cmdResetEQClick(Sender: TObject);
    procedure mnuExportTitleClick(Sender: TObject);
    procedure mnuExportAllTitlesClick(Sender: TObject);
    procedure cmdShowOptionsClick(Sender: TObject);
    procedure cmdLoopStartFirstClick(Sender: TObject);
    procedure cmdLoopStartLastClick(Sender: TObject);
    procedure cmdLoopEndFirstClick(Sender: TObject);
    procedure cmdLoopEndLastClick(Sender: TObject);
       // Private declarations
  		private
			m_manager: CGPManager;
			m_commandLine: CCommandLineManager;
           m_lastOpenFiles: CLastOpenFiles;
			m_commandLineFile: string;
           m_formFirstActivate: boolean;
			m_internalPositionChange: boolean;
			m_internalLoopChange: boolean;
			m_internalSettingsChange: boolean;
			m_destroying: boolean;
			m_canRemove: boolean;
			m_canClear: boolean;
			m_playIndex: integer;
		private
			procedure onPlayStateChanged(Sender: TObject; PlayState: CGPPlayState);
			procedure onPlaySoundSegment(Sender: TObject; SoundSegment: CGPSoundSegment);
			procedure onPlaying(Sender: TObject; Position: currency);
			procedure onActiveSoundSegmentChanged(Sender: TObject);
           procedure onEndTranslation(Sender: TObject);
           procedure onChangeLanguage(Sender: TObject; Language: string);
           procedure onLastOpenFilesPopupClick(Sender: TObject; FileName: string);
		private
			procedure loadOptions;
			procedure saveOptions;
			procedure resetControls;
			procedure syncupControls;
           procedure syncupLoop;
			procedure syncupSettings;
			procedure addTitleFromFile(fileName: string);
			procedure loadGuitarPracticeFile(fileName: string);
			procedure playItem(item: TListItem);
           procedure restartSong;
           procedure restartSongFromEnd;
           procedure playPauseSong;
           procedure removeSelectedSong;
           procedure copySelectedSong;
			procedure clearAllSongs;
			procedure exportSelectedSong;
			procedure exportAllSongs;
           procedure resetEqualizer;
			function openTitle(var fileName: string): boolean;
			function openGuitarPracticeFile(var fileName: string): boolean;
			function openGuitarPracticeFileForSave(var fileName: string): boolean;
		// Public declarations
		public
		end;

var
  FrmGuitarPractice: TFrmGuitarPractice;

implementation

uses
	CGPUtils, CGPConst, CLanguages, CGuitarPracticeLanguageDefinitions;

{$R *.DFM}

//------------------------------------------------------------------------------
// Form creation and destruction
//------------------------------------------------------------------------------

// Form create notification
//
procedure TFrmGuitarPractice.FormCreate(Sender: TObject);
begin
	// Setup the caption
	Application.Title := GP_TITLE + ' ' + GP_VERSION;
   Caption := Application.Title + ' (B' + GP_BUILD + ') - (c) by ' + GP_AUTHOR;

	// Create the manager
	m_manager := CGPManager.Create;
	m_manager.OnPlayStateChanged := onPlayStateChanged;
	m_manager.OnPlaying := onPlaying;
	m_manager.OnPlaySoundSegment := onPlaySoundSegment;
	m_manager.OnActiveSoundSegmentChanged := onActiveSoundSegmentChanged;

   // Create the last open files manager
   m_lastOpenFiles := CLastOpenFiles.Create;
	m_lastOpenFiles.OnPopupItemClick := onLastOpenFilesPopupClick;
   m_lastOpenFiles.PopupMenu := mnuLastOpenFiles;

   // Reset the valid menu hotkeys to prevent use of automatic hotkeys
   ValidMenuHotkeys := '';

	// Init variables
	m_internalPositionChange := false;
	m_internalLoopChange := false;
	m_internalSettingsChange := false;
	m_destroying := false;
	m_canRemove := true;
	m_canClear := true;
	m_commandLineFile := '';
   m_formFirstActivate := true;

	// Reset the controls
	resetControls;

	// Syncup the controls
	syncupControls;

   // Create the command line manager
   m_commandLine := CCommandLineManager.Create;

   // Parse the command line
	m_commandLine.Parse;

   // Register the translation
   theLanguageManager.RegisterTranslation(CGuitarPracticeTranslateDefinition);
end;

// Form destroy notification
//
procedure TFrmGuitarPractice.FormDestroy(Sender: TObject);
begin
	try
   	// Set destroying flag
       m_destroying := true;

   	// Free the manager
       FreeAndNil(m_manager);

       // Free the last open files
       FreeAndNil(m_lastOpenFiles);

       // Release the language manager
       ReleaseLanguageManager;
   finally
   	inherited;
   end;
end;

// Form activate notification
//
procedure TFrmGuitarPractice.FormActivate(Sender: TObject);
begin
	// Validate
   if not m_formFirstActivate then
   	exit;

	// Set form first activate flag
   m_formFirstActivate := false;

   // Enter translation mode
   if m_commandLine.ParamExists(GP_COMMAND_PARAM_TRANSLATE) then
   begin
   	// Connect events
   	theLanguageManager.OnEndTranslation := onEndTranslation;

       // Start the translation
       theLanguageManager.StartTranslation;
   end;

	// Load and start command line file
	if m_commandLine.ParamExists(GP_COMMAND_PARAM_GPFILE) then
	begin
		// Get the command line file
		m_commandLineFile := m_commandLine.ParamValue[GP_COMMAND_PARAM_GPFILE];

		// Check if file has an path
		if (ExtractFilePath(m_commandLineFile) = '') then
			m_commandLineFile := PathIncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + m_commandLineFile;

		// Load the guitar practice file
		loadGuitarPracticeFile(m_commandLineFile);
	end;

	// Load the options
	loadOptions;

	// Load and start command line file
	if m_commandLine.ParamExists(GP_COMMAND_PARAM_PLAY) then
	begin
		try
			// Get the command line file
			m_playIndex := StrToInt(m_commandLine.ParamValue[GP_COMMAND_PARAM_PLAY]);
		except
			// Catch the exception
		end;

		// Validate index
		if (m_playIndex >= 0) and(m_playIndex <= lvwTitles.Items.Count - 1) then
		begin
			// Select the list view item
			lvwTitles.Items[m_playIndex].Selected := true;

			// Play the item
			playItem(lvwTitles.Items[m_playIndex]);
		end;
	end;

   // Connect the language events
   theLanguageManager.OnChangeLanguage := onChangeLanguage;

   // Change the language
   if (m_manager.Options.Language <> '') then
   	theLanguageManager.ChangeLanguage(m_manager.Options.Language);

   // Set the focus to the list view
	lvwTitles.SetFocus;
end;

// Form close notification
//
procedure TFrmGuitarPractice.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	// Save the options
	saveOptions;
end;

// Form key up notification
//
procedure TFrmGuitarPractice.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
	item: TListItem;
   idx: integer;
begin
	// Check for edit or spin edit
	if (ActiveControl is TEdit) or (ActiveControl is TSpinEdit) then
   	exit;

   // Check if for list view and edit mode
   if (ActiveControl is TListView) and (TListView(ActiveControl).IsEditing) then
   	exit;

   // Check for repeat
	if (UpperCase(Chr(Key)) = 'R') and cmdRestart.Enabled then
   	restartSong;

   // Check for repeat from end
	if (UpperCase(Chr(Key)) = 'E') and cmdRestart.Enabled then
   	restartSongFromEnd;

   // Check for play/pause
	if (UpperCase(Chr(Key)) = 'P') and cmdPlay.Enabled then
   	playPauseSong;

   // Check if key is 0 to 9
   if {(Chr(Key) in ['0'..'9'])} CharInSet(Chr(Key),['0'..'9']) and lvwTitles.Enabled and (lvwTitles.Items.Count > 0) then
   begin
   	// Get the key index
		idx := StrToInt(Chr(Key));

       // Convert the key to the index
       if (idx <> 0) then
       	dec(idx)
       else if (idx = 0) then
       	idx := 9;

       // Check for shift (start at entry 10)
       if (ssShift in Shift) then
       	inc(idx,10);

       // Check for ctrl (start at entry 20)
       if (ssCtrl in Shift) then
       	inc(idx,20);

       // Check for alt (start at entry 30)
       if (ssAlt in Shift) then
       	inc(idx,30);

       // Validate the index
       if (idx <= lvwTitles.Items.Count) then
       begin
			// Get the selected item
           item := lvwTitles.Items[idx];

			// Validate item
           if (item <> nil) then
           begin
           	// Select the item
				item.Selected := true;

				// Play the item
				playItem(item);
           end;
       end;
   end;
end;

// Form key down notification
//
procedure TFrmGuitarPractice.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   // Check for list and active item
   if (ActiveControl is TListView) and (TListView(ActiveControl).Selected <> nil) then
   begin
   	// Copy the selected item
   	if (UpperCase(Chr(Key)) = 'C') and (ssCtrl in Shift) and (cmdAddTitle.Enabled) then
       begin
			// Copy the selected song
           copySelectedSong;
       end;

       // Remove the selected item
       if (Key = VK_DELETE) and cmdRemove.Enabled then
       begin
       	// Remove selected song from the list
   		removeSelectedSong;
       end;
   end;
end;

//------------------------------------------------------------------------------
// Public methods
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// List view methods
//------------------------------------------------------------------------------

// On edited of lvwTitles
//
procedure TFrmGuitarPractice.lvwTitlesEdited(Sender: TObject; Item: TListItem; var S: String);
var
	segment: CGPSoundSegment;
begin
	// Validate
	if (Item <> nil) and (Item.Data <> nil) then
	begin
		// Get the segment
		segment := CGPSoundSegment(Item.Data);

		// Update the description
		segment.Description := s;
	end;
end;

// On double click of lvwTitles
//
procedure TFrmGuitarPractice.lvwTitlesDblClick(Sender: TObject);
var
	item: TListItem;
begin
	// Get the selected item
	item := lvwTitles.Selected;

	// Play the item
	playItem(item);
end;

// On change of lvvTitles
//
procedure TFrmGuitarPractice.lvwTitlesChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
	// Syncup the controls
	if not m_destroying then
		syncupControls;
end;

//------------------------------------------------------------------------------
// Loop control methods
//------------------------------------------------------------------------------

// Set the loop flag
//
procedure TFrmGuitarPractice.chkLoopClick(Sender: TObject);
begin
	// Set the loop flag
	if m_manager.HasActiveSoundSegment then
		m_manager.ActiveSoundSegment.Loop := chkLoop.Checked;
end;

// Set loop end to first position
//
procedure TFrmGuitarPractice.cmdLoopEndFirstClick(Sender: TObject);
begin
	// Set loop end to first position
	if m_manager.HasActiveSoundSegment then
	begin
		// Update the controls
		spnLoopEndMinute.Value := 0;
		spnLoopEndSecond.Value := 0;
		spnLoopEndMilli.Value := 0;
	end;
end;

// Set loop end to last position
//
procedure TFrmGuitarPractice.cmdLoopEndLastClick(Sender: TObject);
var
	m,s,ms: integer;
begin
	// Get the current position as loop end
	if m_manager.HasActiveSoundSegment then
	begin
		// Split the seconds
		SplitSeconds(m_manager.ActiveSoundSegment.Seconds,m,s,ms);

		// Update the controls
		spnLoopEndMinute.Value := m;
		spnLoopEndSecond.Value := s;
		spnLoopEndMilli.Value := MilliSecondsToSpinButtonValue(ms);
	end;
end;

// Set loop start to first position
//
procedure TFrmGuitarPractice.cmdLoopStartFirstClick(Sender: TObject);
begin
	// Set loop start to first position
	if m_manager.HasActiveSoundSegment then
	begin
		// Update the controls
		spnLoopStartMinute.Value := 0;
		spnLoopStartSecond.Value := 0;
		spnLoopStartMilli.Value := 0;
	end;
end;

// Set loop start to last position
//
procedure TFrmGuitarPractice.cmdLoopStartLastClick(Sender: TObject);
var
	m,s,ms: integer;
begin
	// Get the current position as loop end
	if m_manager.HasActiveSoundSegment then
	begin
		// Split the seconds
		SplitSeconds(m_manager.ActiveSoundSegment.Seconds,m,s,ms);

		// Update the controls
		spnLoopStartMinute.Value := m;
		spnLoopStartSecond.Value := s;
		spnLoopStartMilli.Value := MilliSecondsToSpinButtonValue(ms);
	end;
end;

// Set loop end
//
procedure TFrmGuitarPractice.cmdSetLoopEndClick(Sender: TObject);
var
	m,s,ms: integer;
begin
	// Get the current position as loop end
	if m_manager.HasActiveSoundSegment then
	begin
		// Split the seconds
		SplitSeconds(m_manager.SoundSystem.Position,m,s,ms);

		// Update the controls
		spnLoopEndMinute.Value := m;
		spnLoopEndSecond.Value := s;
		spnLoopEndMilli.Value := MilliSecondsToSpinButtonValue(ms);
	end;
end;

// Set loop start
//
procedure TFrmGuitarPractice.cmdSetLoopStartClick(Sender: TObject);
var
	m,s,ms: integer;
begin
	// Get the current position as loop end
	if m_manager.HasActiveSoundSegment then
	begin
		// Split the seconds
		SplitSeconds(m_manager.SoundSystem.Position,m,s,ms);

		// Update the controls
		spnLoopStartMinute.Value := m;
		spnLoopStartSecond.Value := s;
       spnLoopStartMilli.Value := MilliSecondsToSpinButtonValue(ms);
	end;
end;

// Set the loop end minute
//
procedure TFrmGuitarPractice.spnLoopEndMinuteChange(Sender: TObject);
begin
	// Set the loop end
	if m_manager.HasActiveSoundSegment then
		m_manager.ActiveSoundSegment.LoopEnd := CalculateSeconds(spnLoopEndMinute.Value,spnLoopEndSecond.Value,TenthMillisecondsToMilliSeconds(spnLoopEndMilli.Value));
end;

// Set the loop end second
//
procedure TFrmGuitarPractice.spnLoopEndSecondChange(Sender: TObject);
begin
	// Set the loop end
	if m_manager.HasActiveSoundSegment then
		m_manager.ActiveSoundSegment.LoopEnd := CalculateSeconds(spnLoopEndMinute.Value,spnLoopEndSecond.Value,TenthMillisecondsToMilliSeconds(spnLoopEndMilli.Value));
end;

// Set the loop end milli second
//
procedure TFrmGuitarPractice.spnLoopEndMilliChange(Sender: TObject);
begin
	// Set the loop end
	if m_manager.HasActiveSoundSegment then
		m_manager.ActiveSoundSegment.LoopEnd := CalculateSeconds(spnLoopEndMinute.Value,spnLoopEndSecond.Value,TenthMillisecondsToMilliSeconds(spnLoopEndMilli.Value));
end;

// Set the loop start minute
//
procedure TFrmGuitarPractice.spnLoopStartMinuteChange(Sender: TObject);
begin
	// Set the loop start
	if m_manager.HasActiveSoundSegment then
		m_manager.ActiveSoundSegment.LoopStart := CalculateSeconds(spnLoopStartMinute.Value,spnLoopStartSecond.Value,TenthMillisecondsToMilliSeconds(spnLoopStartMilli.Value));
end;

// Set the loop start second
//
procedure TFrmGuitarPractice.spnLoopStartSecondChange(Sender: TObject);
begin
	// Set the loop start
	if m_manager.HasActiveSoundSegment then
		m_manager.ActiveSoundSegment.LoopStart := CalculateSeconds(spnLoopStartMinute.Value,spnLoopStartSecond.Value,TenthMillisecondsToMilliSeconds(spnLoopStartMilli.Value));
end;

// Set the loop start milli second
//
procedure TFrmGuitarPractice.spnLoopStartMilliChange(Sender: TObject);
begin
	// Set the loop start
	if m_manager.HasActiveSoundSegment then
		m_manager.ActiveSoundSegment.LoopStart := CalculateSeconds(spnLoopStartMinute.Value,spnLoopStartSecond.Value,TenthMillisecondsToMilliSeconds(spnLoopStartMilli.Value));
end;

//------------------------------------------------------------------------------
// Song control methods
//------------------------------------------------------------------------------

// Start new guitar practice file
//
procedure TFrmGuitarPractice.cmdNewClick(Sender: TObject);
begin
	// Ask user
	if MessageDlg(theLanguageManager.Variables[GP_MESSAGE_FILE_NEW],mtConfirmation,[mbYes, mbNo],0) = mrYes then
   begin
		// Clear the title
		txtTitleDescription.Text := '';

       // Reset the file name
       m_manager.GPFile.Reset;

   	// Clear all songs from the playlist
		clearAllSongs;

       // Set focus to the title
       txtTitleDescription.SetFocus;
   end;
end;

// Open guitar practice file
//
procedure TFrmGuitarPractice.cmdOpenClick(Sender: TObject);
var
	fileName: string;
begin
	// Get the current file name
	fileName := m_manager.GPFile.Name;

	// Open the guitar practive file
	if openGuitarPracticeFile(fileName) then
	begin
   	// Stop the manager
   	m_manager.Stop;

   	// Stop the sound system
		m_manager.SoundSystem.Stop;

		// Deinitialize the sound system
		m_manager.SoundSystem.Deinitialize;
		try
			loadGuitarPracticeFile(fileName);
		finally
			// Reinitialize the sound system
			m_manager.SoundSystem.Initialize;
		end;
	end;
end;

// Save guitar practice file
//
procedure TFrmGuitarPractice.cmdSaveClick(Sender: TObject);
var
	fileName: string;
begin
	// Get the current file name
	fileName := m_manager.GPFile.Name;

	// Open the guitar practive file for save
	if openGuitarPracticeFileForSave(fileName) then
	begin
		// Update the title
		m_manager.GPFile.Title := txtTitleDescription.Text;

		// Save the file
		m_manager.GPFile.Save(fileName);

       // Add to the last open files list
       m_lastOpenFiles.Add(fileName);
	end;
end;

// Add a new title to the song list
//
procedure TFrmGuitarPractice.cmdAddTitleClick(Sender: TObject);
var
	fileName: string;
begin
	// Add title from file
	if openTitle(fileName) then
		addTitleFromFile(fileName);

	// Syncup the controls
	syncupControls;
end;

// Clear all files
//
procedure TFrmGuitarPractice.cmdClearClick(Sender: TObject);
begin
   // Clear all songs from the playlist
	clearAllSongs;
end;

// Remove song segment from list
//
procedure TFrmGuitarPractice.cmdRemoveClick(Sender: TObject);
begin
	// Remove selected song from the list
   removeSelectedSong;
end;

//------------------------------------------------------------------------------
// Miscellaneous control methods
//------------------------------------------------------------------------------

// Show the about dialog
//
procedure TFrmGuitarPractice.cmdAboutClick(Sender: TObject);
var
	frm: TFrmGuitarPracticeAbout;
begin
	// Create the form
	frm := TFrmGuitarPracticeAbout.Create(self);
	try
		// Show the form as modal dialog
		frm.ShowModal;
	finally
		// Free the form
		FreeAndNil(frm);
	end;
end;

// Show the options
//
procedure TFrmGuitarPractice.cmdShowOptionsClick(Sender: TObject);
var
	frm: TFrmGuitarPracticeOptions;
begin
	// Create the form
	frm := TFrmGuitarPracticeOptions.Create(self);
	try
		// Show the form as modal dialog
		if frm.Execute(m_manager) then
		begin
			// Setup last open files history
			m_lastOpenFiles.MaxFiles := m_manager.Options.KeepFileHistory;
		end;
	finally
		// Free the form
		FreeAndNil(frm);
   end;
end;

//------------------------------------------------------------------------------
// Settings control methods
//------------------------------------------------------------------------------

// Reset the panning
//
procedure TFrmGuitarPractice.cmdResetPanningClick(Sender: TObject);
begin
	scbPanning.Position := 0;
end;

// Reset the pitch
//
procedure TFrmGuitarPractice.cmdResetPitchClick(Sender: TObject);
begin
	scbPitch.Position := 0;
end;

// Reset the sample rate
//
procedure TFrmGuitarPractice.cmdResetRateClick(Sender: TObject);
begin
	// Default to 44 khz
	scbRate.Position := 44100;
end;

// Reset the tempo
//
procedure TFrmGuitarPractice.cmdResetTempoClick(Sender: TObject);
begin
	scbTempo.Position := 0;
end;

// Reset the volume
//
procedure TFrmGuitarPractice.cmdResetVolumeClick(Sender: TObject);
begin
	scbVolume.Position := 100;
end;

// On change of scbPanning
//
procedure TFrmGuitarPractice.scbPanningChange(Sender: TObject);
var
	prefix: string;
begin
	// Validate
	if not m_manager.HasActiveSoundSegment then
		exit;

	// Update the segment and sound system
	m_manager.ActiveSoundSegment.Panning := scbPanning.Position;
	m_manager.SoundSystem.Panning := m_manager.ActiveSoundSegment.Panning;

	// Get the suffix
	prefix := '';
	if (m_manager.ActiveSoundSegment.Panning > 0) then
		prefix := 'R '
	else if (m_manager.ActiveSoundSegment.Panning < 0) then
		prefix := 'L ';

	// Update the caption
	lblDisplayPanning.Caption := prefix + IntToStr(Abs(m_manager.ActiveSoundSegment.Panning)) + '%';
end;

// On change of scbPitch
//
procedure TFrmGuitarPractice.scbPitchChange(Sender: TObject);
begin
	// Validate
	if not m_manager.HasActiveSoundSegment then
		exit;

	// Update the segment and sound system
	m_manager.ActiveSoundSegment.Pitch := scbPitch.Position;
	m_manager.SoundSystem.Pitch := m_manager.ActiveSoundSegment.Pitch;

	// Update the caption
	lblDisplayPitch.Caption := IntToStr(m_manager.ActiveSoundSegment.Pitch) + 'ht';
end;

// On change of scbRate
//
procedure TFrmGuitarPractice.scbRateChange(Sender: TObject);
var
	sr: single;
begin
	// Validate
	if not m_manager.HasActiveSoundSegment then
		exit;

	// Update the segment and sound system
	m_manager.ActiveSoundSegment.SampleRate := scbRate.Position;
	m_manager.SoundSystem.SampleRate := m_manager.ActiveSoundSegment.SampleRate;

	// Calculate the sample rate in kHz
	sr := m_manager.ActiveSoundSegment.SampleRate / 1000;

	// Update the caption
	lblDisplayRate.Caption := FormatFloat('#0.0',sr) + 'khz';
end;

// On change of scbTempo
//
procedure TFrmGuitarPractice.scbTempoChange(Sender: TObject);
var
	t: integer;
begin
	// Validate
	if not m_manager.HasActiveSoundSegment then
		exit;

	// Update the segment and sound system
	m_manager.ActiveSoundSegment.Tempo := scbTempo.Position;
	m_manager.SoundSystem.Tempo := m_manager.ActiveSoundSegment.Tempo;

   // Calculate the tempo
   t := 100 + m_manager.ActiveSoundSegment.Tempo;

	// Update the caption
	lblDisplayTempo.Caption := IntToStr(t) + '%';
end;

// On change of scbVolume
//
procedure TFrmGuitarPractice.scbVolumeChange(Sender: TObject);
begin
	// Validate
	if not m_manager.HasActiveSoundSegment then
		exit;

	// Update the segment and sound system
	m_manager.ActiveSoundSegment.Volume := scbVolume.Position;
	m_manager.SoundSystem.Volume := m_manager.ActiveSoundSegment.Volume;

	// Update the caption
	lblDisplayVolume.Caption := IntToStr(m_manager.ActiveSoundSegment.Volume) + '%';
end;

//------------------------------------------------------------------------------
// Play control methods
//------------------------------------------------------------------------------

// Restart the current segment
//
procedure TFrmGuitarPractice.cmdRestartClick(Sender: TObject);
begin
	// Restart the song
   restartSong;
end;

// On change of scbPosition
//
procedure TFrmGuitarPractice.scbPositionChange(Sender: TObject);
begin
	// Check for internal position change
	if m_internalPositionChange then
		exit;

	// Change position
	m_manager.SoundSystem.Position := BarPositionToPosition(scbPosition.Position);

	// Update current position
	lblCurrentPosition.Caption := SecondsToTimeString(Trunc(m_manager.SoundSystem.Position));
end;

// On click of cmdPlay
//
procedure TFrmGuitarPractice.cmdPlayClick(Sender: TObject);
begin
	// Play or pause the song
   playPauseSong;
end;

//------------------------------------------------------------------------------
// Popup menu events
//------------------------------------------------------------------------------

// On popup of mnuTitles
//
procedure TFrmGuitarPractice.mnuTitlesPopup(Sender: TObject);
begin
	// Enable / Disable menu items
	mnuCopyTitle.Enabled := (lvwTitles.Selected <> nil);
	mnuAddTitle.Enabled := cmdAddTitle.Enabled;
	mnuClearTitles.Enabled := cmdClear.Enabled;
	mnuRemoveTitle.Enabled := cmdRemove.Enabled;
	mnuExportTitle.Enabled := (lvwTitles.Selected <> nil) and m_manager.Options.CanExport; 
	mnuExportAllTitles.Enabled := (lvwTitles.Items.Count > 0) and m_manager.Options.CanExport; 
end;

// Copy the currently selected title
//
procedure TFrmGuitarPractice.mnuCopyTitleClick(Sender: TObject);
begin
	// Copy the selected song
	copySelectedSong;
end;

// Export selected title
//
procedure TFrmGuitarPractice.mnuExportAllTitlesClick(Sender: TObject);
begin
	// Export all songs
	exportAllSongs;
end;

procedure TFrmGuitarPractice.mnuExportTitleClick(Sender: TObject);
begin
	// Export the selected song
	exportSelectedSong;
end;

// Add new title to the list
//
procedure TFrmGuitarPractice.mnuAddTitleClick(Sender: TObject);
begin
	// Delegate to button
	cmdAddTitle.Click;
end;

// Remove the currently selected title
//
procedure TFrmGuitarPractice.mnuRemoveTitleClick(Sender: TObject);
begin
	// Delegate to button
	cmdRemove.Click;
end;

// Clear all titles
//
procedure TFrmGuitarPractice.mnuClearTitlesClick(Sender: TObject);
begin
	// Delegate to button
	cmdClear.Click;
end;

// On click of cmdLastOpenFiles
//
procedure TFrmGuitarPractice.cmdLastOpenFilesClick(Sender: TObject);
var
	p: TPoint;
begin
	// Get the popup coordinates
	p.X := cmdOpen.Left + 4;
   p.Y := cmdLastOpenFiles.Top + cmdLastOpenFiles.Height + 4;

   // Calculate screen coordinates from point
   p := ClientToScreen(p);

   // Display popup menu
   mnuLastOpenFiles.Popup(p.X,p.Y);
end;

// On click of popup mnuLastOpenFiles
//
procedure TFrmGuitarPractice.onLastOpenFilesPopupClick(Sender: TObject; FileName: string);
begin
	// Stop the manager
   m_manager.Stop;

	// Stop the sound system
   m_manager.SoundSystem.Stop;

   // Deinitialize the sound system
   m_manager.SoundSystem.Deinitialize;
   try
   	loadGuitarPracticeFile(FileName);
   finally
   	// Reinitialize the sound system
       m_manager.SoundSystem.Initialize;
   end;
end;

//------------------------------------------------------------------------------
// Equalizer controls and methods
//------------------------------------------------------------------------------

// Close the equalizer
//
procedure TFrmGuitarPractice.cmdCloseEQClick(Sender: TObject);
begin
	// Hide the equalizer
   grpEQ.Visible := false;

   // Send to back
   grpEQ.SendToBack;
end;

// Open the equalizer
//
procedure TFrmGuitarPractice.cmdOpenEQClick(Sender: TObject);
begin
	// Show the equalizer
   grpEQ.Visible := true;

   // Bring to front
   grpEQ.BringToFront;
end;

// Reset equalizer
//
procedure TFrmGuitarPractice.cmdResetEQClick(Sender: TObject);
begin
	// Reset the equalizer
   resetEqualizer;
end;

// On change of scbBand1
//
procedure TFrmGuitarPractice.scbBand1Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band1Gain := scbBand1.Position;
end;

// On change of scbBand2
//
procedure TFrmGuitarPractice.scbBand2Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band2Gain := scbBand2.Position;
end;

// On change of scbBand3
//
procedure TFrmGuitarPractice.scbBand3Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band3Gain := scbBand3.Position;
end;

// On change of scbBand4
//
procedure TFrmGuitarPractice.scbBand4Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band4Gain := scbBand4.Position;
end;

// On change of scbBand5
//
procedure TFrmGuitarPractice.scbBand5Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band5Gain := scbBand5.Position;
end;

// On change of scbBand6
//
procedure TFrmGuitarPractice.scbBand6Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band6Gain := scbBand6.Position;
end;

// On change of scbBand7
//
procedure TFrmGuitarPractice.scbBand7Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band7Gain := scbBand7.Position;
end;

// On change of scbBand8
//
procedure TFrmGuitarPractice.scbBand8Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band8Gain := scbBand8.Position;
end;

// On change of scbBand9
//
procedure TFrmGuitarPractice.scbBand9Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band9Gain := scbBand9.Position;
end;

// On change of scbBand10
//
procedure TFrmGuitarPractice.scbBand10Change(Sender: TObject);
begin
	m_manager.SoundSystem.Equalizer.Band10Gain := scbBand10.Position;
end;

//------------------------------------------------------------------------------
// Event methods
//------------------------------------------------------------------------------

// Play state changed
//
procedure TFrmGuitarPractice.onPlayStateChanged(Sender: TObject; PlayState: CGPPlayState);
begin
	case PlayState of
		// Playing
		psPlaying:
			begin
				cmdPlay.Caption := '<';
				scbPosition.Enabled := true;
				cmdRestart.Enabled := true;
				cmdOpen.Enabled := true;
               cmdNew.Enabled := true;
               cmdLastOpenFiles.Enabled := true;
				lvwTitles.Enabled := true;
				m_canRemove := true;
				m_canClear := true;
			end;
		// Stopped
		psStopped:
			begin
				cmdPlay.Caption := '4';
				scbPosition.Enabled := false;
				cmdRestart.Enabled := false;
			 {	cmdOpen.Enabled := false;
               cmdNew.Enabled := false;
               cmdLastOpenFiles.Enabled := false;
				lvwTitles.Enabled := false;
				m_canRemove := false;
				m_canClear := false;  }
			end;     
	end;

	// Syncup the controls
	syncupControls;
end;

// Playing event
//
procedure TFrmGuitarPractice.onPlaying(Sender: TObject; Position: currency);
begin
	// Set internal position change flag
	m_internalPositionChange := true;
	try
		// Update scrollbar
		scbPosition.Position := PositionToBarPosition(Position);

		// Update current position
		lblCurrentPosition.Caption := SecondsToTimeString(Trunc(Position));
	finally
		// Reset internal position change flag
		m_internalPositionChange := false;
	end;
end;

// Play sound segment event
//
procedure TFrmGuitarPractice.onPlaySoundSegment(Sender: TObject; SoundSegment: CGPSoundSegment);
begin
	// Syncup the setting controls
	syncupSettings;

	// Syncup the loop controls
	syncupLoop;

	// Init position scroll bar
	scbPosition.Min := 0;
	scbPosition.Max := PositionToBarPosition(SoundSegment.Seconds);
	scbPosition.Position := PositionToBarPosition(m_manager.SoundSystem.Position);

	// Update the channel length caption
	lblChannelLength.Caption := SecondsToTimeString(SoundSegment.Seconds);
end;

// On change of the active sound segment
//
procedure TFrmGuitarPractice.onActiveSoundSegmentChanged(Sender: TObject);
begin
	// Syncup the controls
	syncupControls;
end;

//------------------------------------------------------------------------------
// Translation methods and events
//------------------------------------------------------------------------------

// Change the language
//
procedure TFrmGuitarPractice.cmdChangeLanguageClick(Sender: TObject);
begin
	// Choose language
   theLanguageManager.ChooseLanguage;
end;

// End translation notification
//
procedure TFrmGuitarPractice.onEndTranslation(Sender: TObject);
begin
	// Terminate the application
	Application.Terminate;
end;

// Change language notification
//
procedure TFrmGuitarPractice.onChangeLanguage(Sender: TObject; Language: string);
begin
   // Translate the form
	theLanguageManager.TranslateForm(self);

   // Update variables
   lblSongTitle.Caption := theLanguageManager.Variables[GP_VARIABLE_SONGTITLE];
   lvwTitles.Columns[0].Caption := theLanguageManager.Variables[GP_VARIABLE_TITLE_DESCRIPTION];
   lvwTitles.Columns[1].Caption := theLanguageManager.Variables[GP_VARIABLE_TITLE_FILENAME];

   // Store the language
   m_manager.Options.Language := theLanguageManager.CurrentLanguage;
end;

//------------------------------------------------------------------------------
// Private methods
//------------------------------------------------------------------------------

// Syncup the controls
//
procedure TFrmGuitarPractice.syncupControls;
begin
	grpPlay.Enabled := m_manager.HasActiveSoundSegment;
	grpLoop.Enabled := m_manager.HasActiveSoundSegment;
	grpSettings.Enabled := m_manager.HasActiveSoundSegment;
	cmdSave.Enabled := (lvwTitles.Items.Count > 0);
	cmdRemove.Enabled := (lvwTitles.Items.Count > 0) and (lvwTitles.Selected <> nil) and m_canRemove;
	cmdClear.Enabled := (lvwTitles.Items.Count > 0) and m_canClear;
end;

// Reset controls
//
procedure TFrmGuitarPractice.resetControls;
begin
	scbPosition.Position := 0;
   lblCurrentPosition.Caption := '00:00:00';
   lblChannelLength.Caption := '00:00:00';
   chkLoop.Checked := false;
   spnLoopStartMinute.Value := 0;
   spnLoopStartSecond.Value := 0;
   spnLoopEndMinute.Value := 0;
   spnLoopEndSecond.Value := 0;
   scbVolume.Position := 0;
   scbPanning.Position := -100;
   scbTempo.Position := -95;
   scbRate.Position := 1000;
   scbPitch.Position := -60;
   lblDisplayVolume.Caption := '0%';
   lblDisplayPanning.Caption := '0%';
   lblDisplayTempo.Caption := '0%';
   lblDisplayRate.Caption := '0khz';
	lblDisplayPitch.Caption := '0ht';
	lblSongTitle.Caption := GP_VARIABLE_SONGTITLE_DEFAULT;

   // Hide the equalizer
   grpEQ.Visible := false;

	// Reset equalizer
   resetEqualizer;
end;

// Syncup the settings
//
procedure TFrmGuitarPractice.syncupSettings;
begin
	// Check for active sound segment
	if m_manager.HasActiveSoundSegment then
	begin
		// Update the properties
		scbVolume.Position := m_manager.ActiveSoundSegment.Volume;
		scbPanning.Position := m_manager.ActiveSoundSegment.Panning;
		scbTempo.Position := m_manager.ActiveSoundSegment.Tempo;
		scbRate.Position := m_manager.ActiveSoundSegment.SampleRate;
		scbPitch.Position := m_manager.ActiveSoundSegment.Pitch;
	end;
end;

// Syncup the loop controls
//
procedure TFrmGuitarPractice.syncupLoop;
var
	m,s,ms: integer;
begin
	// Check for active sound segment
	if m_manager.HasActiveSoundSegment then
	begin
   	// Get the loop
   	chkLoop.Checked := m_manager.ActiveSoundSegment.Loop;

		// Split the seconds
		SplitSeconds(m_manager.ActiveSoundSegment.LoopStart,m,s,ms);

		// Update the controls
		spnLoopStartMinute.Value := m;
		spnLoopStartSecond.Value := s;
       spnLoopStartMilli.Value := MilliSecondsToTenthMilliseconds(ms);

		// Split the seconds
		SplitSeconds(m_manager.ActiveSoundSegment.LoopEnd,m,s,ms);

		// Update the controls
		spnLoopEndMinute.Value := m;
		spnLoopEndSecond.Value := s;
       spnLoopEndMilli.Value := MilliSecondsToTenthMilliseconds(ms);
	end;
end;

// Add a new segment from file
//
procedure TFrmGuitarPractice.addTitleFromFile(fileName: string);
var
	segment: CGPSoundSegment;
	item: TListItem;
begin
	// Add new sound segment
	segment := m_manager.AddSoundSegment(fileName);

	// Add segment to list view
	item := lvwTitles.Items.Add;

	// Setup item properties
	item.Caption := segment.Description;
	item.SubItems.Add(segment.ShortFileName);
	item.Data := segment;
end;

// Open file with dialog
//
function TFrmGuitarPractice.openTitle(var fileName: string): boolean;
var
	dlg: TOpenDialog;
begin
	// Initialize result
	fileName := '';

	// Create the dialog
	dlg := TOpenDialog.Create(self);
   try
		// Setup properties
		dlg.Filter := GP_SOUNDFILE_FILTER;

       // Setup initial dir
       if (m_manager.Options.CurrentMP3Directory <> '') and (DirectoryExists(m_manager.Options.CurrentMP3Directory)) then
           dlg.InitialDir := PathIncludeTrailingBackslash(m_manager.Options.CurrentMP3Directory); 
       
		// Execute the dialog
		if dlg.Execute then
       begin
           // Get filename
			fileName := dlg.Filename;

           // Store last used directory
           m_manager.Options.CurrentMP3Directory := PathIncludeTrailingBackslash(ExtractFileDir(dlg.Filename));
       end;
   finally
		// Free the dialog
   	FreeAndNil(dlg);

		// Determine result
		result := (fileName <> '') and FileExists(fileName);
	end;
end;

// Open guitar practice file with dialog
//
function TFrmGuitarPractice.openGuitarPracticeFile(var fileName: string): boolean;
var
	dlg: TOpenDialog;
begin
	// Initialize result
	fileName := '';

	// Create the dialog
	dlg := TOpenDialog.Create(self);
	try
		// Setup properties
		dlg.Filter := GP_GUITARPRACTICEFILE_FILTER;
		dlg.DefaultExt := GP_GUITARPRACTICEFILE_EXTENSION;

		// Set the filename
		dlg.FileName := fileName;

       // Setup initial dir
       if (m_manager.Options.CurrentGPFDirectory <> '') and (DirectoryExists(m_manager.Options.CurrentGPFDirectory)) then
           dlg.InitialDir := PathIncludeTrailingBackslash(m_manager.Options.CurrentGPFDirectory); 

		// Execute the dialog
		if dlg.Execute then
       begin
           // Get filename
			fileName := dlg.Filename;

           // Store last used directory
           m_manager.Options.CurrentGPFDirectory := PathIncludeTrailingBackslash(ExtractFileDir(dlg.Filename));
       end;
	finally
		// Free the dialog
		FreeAndNil(dlg);

		// Determine result
		result := (fileName <> '') and FileExists(fileName);
	end;
end;

// Open guitar practice file for save with dialog
//
function TFrmGuitarPractice.openGuitarPracticeFileForSave(var fileName: string): boolean;
var
	dlg: TSaveDialog;
begin
	// Create the dialog
	dlg := TSaveDialog.Create(self);
	try
		// Setup properties
		dlg.Filter := GP_GUITARPRACTICEFILE_FILTER;
		dlg.DefaultExt := GP_GUITARPRACTICEFILE_EXTENSION;

		// Set the filename
		dlg.FileName := fileName;

       // Setup initial dir
       if (m_manager.Options.CurrentGPFDirectory <> '') and (DirectoryExists(m_manager.Options.CurrentGPFDirectory)) then
           dlg.InitialDir := PathIncludeTrailingBackslash(m_manager.Options.CurrentGPFDirectory); 
       
		// Execute the dialog
		if dlg.Execute then
       begin
           // Get filename
			fileName := dlg.Filename;

           // Store last used directory
           m_manager.Options.CurrentGPFDirectory := PathIncludeTrailingBackslash(ExtractFileDir(dlg.Filename));
       end;
	finally
		// Free the dialog
		FreeAndNil(dlg);

		// Determine result
		result := (fileName <> '');
	end;
end;

// Load the options
//
procedure TFrmGuitarPractice.loadOptions;
begin
	// Load the options
	m_manager.Options.Load;

	// Set the top position
	if (m_manager.Options.Top <> -1) then
		Top := m_manager.Options.Top;

	// Set the left position
	if (m_manager.Options.Left <> -1) then
		Left := m_manager.Options.Left;

	// Set the width
	if (m_manager.Options.Width <> -1) then
		Width := m_manager.Options.Width;

	// Set the height
	if (m_manager.Options.Height <> -1) then
		Height := m_manager.Options.Height;

	// Setup last open files history
	m_lastOpenFiles.MaxFiles := m_manager.Options.KeepFileHistory;
	
	// Load the last open files
   if (m_manager.Options.LastOpenFiles <> '') then
   	m_lastOpenFiles.AsString := m_manager.Options.LastOpenFiles;

	// Load the last open file
	if (m_manager.Options.LastOpenFileName <> '') and (m_commandLineFile = '') then
		loadGuitarPracticeFile(m_manager.Options.LastOpenFileName);
end;

// Save the options
//
procedure TFrmGuitarPractice.saveOptions;
begin
	// Store the last open file name
	m_manager.Options.LastOpenFileName := m_manager.GPFile.Name;

	// Store form properties
	m_manager.Options.Left := Left;
	m_manager.Options.Top := Top;
	m_manager.Options.Width := Width;
	m_manager.Options.Height := Height;

   // Store the last open files
   if (m_lastOpenFiles.AsString <> '') then
   	m_manager.Options.LastOpenFiles := m_lastOpenFiles.AsString;

	// Save the options
	m_manager.Options.Save;
end;

// Load the guitar practice file
//
procedure TFrmGuitarPractice.loadGuitarPracticeFile(fileName: string);
var
	segment: CGPSoundSegment;
	item: TListItem;
	i: integer;
begin
	// Validate
	if not FileExists(fileName) then
		exit;

	// Reset the controls
	resetControls;
	try
		// Clear the list view
		lvwTitles.Items.Clear;

		// Load the guitar practice file
		m_manager.GPFile.Load(fileName);

		// Load all the sound segments to list view
		for i := 0 to m_manager.SoundSegments.Count - 1 do
		begin
			// Get the segment
			segment := m_manager.SoundSegments[i];

			// Add segment to list view
			item := lvwTitles.Items.Add;

			// Setup item properties
			item.Caption := segment.Description;
			item.SubItems.Add(segment.ShortFileName);
			item.Data := segment;
		end;

		// Setup title
       txtTitleDescription.Text := m_manager.GPFile.Title;

       // Set the equalizer
   	scbBand1.Position := m_manager.SoundSystem.Equalizer.Band1Gain;
   	scbBand2.Position := m_manager.SoundSystem.Equalizer.Band2Gain;
   	scbBand3.Position := m_manager.SoundSystem.Equalizer.Band3Gain;
   	scbBand4.Position := m_manager.SoundSystem.Equalizer.Band4Gain;
   	scbBand5.Position := m_manager.SoundSystem.Equalizer.Band5Gain;
   	scbBand6.Position := m_manager.SoundSystem.Equalizer.Band6Gain;
   	scbBand7.Position := m_manager.SoundSystem.Equalizer.Band7Gain;
   	scbBand8.Position := m_manager.SoundSystem.Equalizer.Band8Gain;
   	scbBand9.Position := m_manager.SoundSystem.Equalizer.Band9Gain;
   	scbBand10.Position := m_manager.SoundSystem.Equalizer.Band10Gain;

       // Add to the last open files list
       m_lastOpenFiles.Add(fileName);
	finally
		// Syncup the controls
		syncupControls;
	end;
end;

// Play the given list item
//
procedure TFrmGuitarPractice.playItem(item: TListItem);
begin
	// Check if item exists
	if (item <> nil) then
	begin
		// Play the sound segment
		m_manager.PlaySoundSegment(item.Index);

		// Syncup caption
		lblSongTitle.Caption := item.Caption;

		// Syncup the controls
		syncupControls;
	end;
end;

// Restart the song
//
procedure TFrmGuitarPractice.restartSong;
begin
	// Validate
	if not m_manager.HasActiveSoundSegment then
		exit;

	// Check if loop
	if m_manager.ActiveSoundSegment.CanLoop then
		scbPosition.Position := PositionToBarPosition(m_manager.ActiveSoundSegment.LoopStart)
	else
		scbPosition.Position := 0;
end;

// Restart the song from end
//
procedure TFrmGuitarPractice.restartSongFromEnd;
var
	playTime: currency;
const
	CONST_SECONDSFROMEND_MARGIN = 8;
begin
	// Validate
	if not m_manager.HasActiveSoundSegment then
		exit;

   // Get the playtime
   playTime := m_manager.ActiveSoundSegment.Playtime;

   // Check if we can substract 8 seconds
   if (playTime < CONST_SECONDSFROMEND_MARGIN) then
   	exit;

	// Check if loop
	if m_manager.ActiveSoundSegment.CanLoop then
		// Calculate the new start point, that is 8 seconds to the end of segment
		scbPosition.Position := PositionToBarPosition(m_manager.ActiveSoundSegment.LoopEnd - CONST_SECONDSFROMEND_MARGIN)
	else
      	// Calculate the new start point, that is 8 seconds to the end of the song
		scbPosition.Position := PositionToBarPosition(m_manager.ActiveSoundSegment.Seconds - CONST_SECONDSFROMEND_MARGIN);
end;

// Play pause song
//
procedure TFrmGuitarPractice.playPauseSong;
begin
	// Pause or resume the current segment
	if m_manager.HasActiveSoundSegment then
		m_manager.PlayPauseSoundSegment;
end;

// Remove the selected song
//
procedure TFrmGuitarPractice.removeSelectedSong;
var
	item: TListItem;
begin
	// Get the selected item
	item := lvwTitles.Selected;

   // Check if item exists
   if (item <> nil) then
	begin
		// Stop the sound system
		m_manager.SoundSystem.Stop;

       // Delete the sound segment
       m_manager.SoundSegments.Delete(item.Index);

		// Delete the item
		item.Delete;

		// Reset active sound segment
		m_manager.ActiveSoundSegment := nil;
	end;

	// Reset the controls
   resetControls;

	// Syncup the controls
	syncupControls;
end;

// Copy the selected song
//
procedure TFrmGuitarPractice.copySelectedSong;
var
	item: TListItem;
	sourceSegment, targetSegment: CGPSoundSegment;
begin
	// Get the current selected item
	item := lvwTitles.Selected;

	// No item selected -> nothing more to do
	if (item = nil) then
		exit;

	// Get the source segment
	sourceSegment := CGPSoundSegment(item.Data);

	// Check if source segment valid
	if (sourceSegment <> nil) then
	begin
		// Add target segment and copy the properties
		targetSegment := m_manager.SoundSegments.CopyAndAddSoundSegment(sourceSegment);

		// Add segment to list view
		item := lvwTitles.Items.Add;

		// Setup item properties
		item.Caption := targetSegment.Description;
		item.SubItems.Add(targetSegment.ShortFileName);
		item.Data := targetSegment;
	end;
end;

// Clear all songs
//
procedure TFrmGuitarPractice.clearAllSongs;
begin
   // Stop the sound system
	m_manager.Stop;

	// Deinitialize the sound system
	m_manager.SoundSystem.Deinitialize;
	try
		// Reset the controls
		resetControls;

		// Clear the list view
		lvwTitles.Items.Clear;

		// Clear the segments
		m_manager.SoundSegments.Reset;

		// Syncup the controls
		syncupControls;
	finally
		// Reinitialize the sound system
		m_manager.SoundSystem.Initialize;
	end;
end;

// Export the selected song
//
procedure TFrmGuitarPractice.exportSelectedSong;
var
	item: TListItem;
begin
	// Get the current selected item
	item := lvwTitles.Selected;

	// No item selected -> nothing more to do
	if (item = nil) then
		exit;

	// Encode the sound segment
	m_manager.EncodeSoundSegment(item.Index);

	// Show message dialog
	MessageDlg(theLanguageManager.Variables[GP_MESSAGE_FILE_EXPORT_COMPLETE],mtInformation,[mbOk],0)
end;

// Export all songs
//
procedure TFrmGuitarPractice.exportAllSongs;
var
	item: TListItem;
	i: integer;
begin
	for i := 0 to lvwTitles.Items.Count - 1 do
	begin
		// Get the current selected item
		item := lvwTitles.Items[i];

		// No item selected -> nothing more to do
		if (item = nil) then
			exit;

		// Encode the sound segment
		m_manager.EncodeSoundSegment(item.Index);
	end;

	// Show message dialog
	MessageDlg(theLanguageManager.Variables[GP_MESSAGE_FILE_EXPORT_COMPLETE],mtInformation,[mbOk],0)
end;

// Reset the equalizer
//
procedure TFrmGuitarPractice.resetEqualizer;
begin
   // Reset equalizer controls
   scbBand1.Position := 10;
   scbBand2.Position := 10;
   scbBand3.Position := 10;
   scbBand4.Position := 10;
   scbBand5.Position := 10;
   scbBand6.Position := 10;
   scbBand7.Position := 10;
   scbBand8.Position := 10;
   scbBand9.Position := 10;
   scbBand10.Position := 10;

   // Reset the equalizer
   m_manager.SoundSystem.Equalizer.Band1Gain := scbBand1.Position;
   m_manager.SoundSystem.Equalizer.Band2Gain := scbBand2.Position;
   m_manager.SoundSystem.Equalizer.Band3Gain := scbBand3.Position;
   m_manager.SoundSystem.Equalizer.Band4Gain := scbBand4.Position;
   m_manager.SoundSystem.Equalizer.Band5Gain := scbBand5.Position;
   m_manager.SoundSystem.Equalizer.Band6Gain := scbBand6.Position;
   m_manager.SoundSystem.Equalizer.Band7Gain := scbBand7.Position;
   m_manager.SoundSystem.Equalizer.Band8Gain := scbBand8.Position;
   m_manager.SoundSystem.Equalizer.Band9Gain := scbBand9.Position;
   m_manager.SoundSystem.Equalizer.Band10Gain := scbBand10.Position;
end;

end.
