//------------------------------------------------------------------------------
// Guitar Practice
//------------------------------------------------------------------------------
//
//	Version:		1.0
//
//	Synopsis:		The guitar practice progress form.
//
//	Description:   	This unit implements the progress form of the
//                 guitar practice system
//
// Created:		FeMann
// Date:			14.03.2010
//
// (c) Copyright by FeMann.
// All rights reserved.
//
//

unit UFrmGuitarPracticeProgress;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls;

type	
	// The guitar practice progress form
	//
	TFrmGuitarPracticeProgress = class(TForm)
    bvlBase: TBevel;
    lblEncoding: TLabel;
    lblOutputDirectory: TLabel;
    lblOutputFileName: TLabel;
    barProgress: TProgressBar;
    procedure FormCreate(Sender: TObject);
	// Private declarations
	private
		function getOutputFileName: string;
		procedure setOutputFileName(val: string);
		function getOutputDirectory: string;
		procedure setOutputDirectory(val: string);
		function getProgress: integer;
		procedure setProgress(val: integer);
	// Public declarations
	public
		procedure Execute(maxProgress: integer);
	public
		property OutputFileName: string read getOutputFileName write setOutputFileName;
		property OutputDirectory: string read getOutputDirectory write setOutputDirectory;
		property Progress: integer read getProgress write setProgress;
	end;

var
  FrmGuitarPracticeProgress: TFrmGuitarPracticeProgress;

implementation

uses
	CLanguages;

{$R *.dfm}

//--------------------------------------------------------------------------
// Constructor and destructor
//--------------------------------------------------------------------------

// Form create notification
//
procedure TFrmGuitarPracticeProgress.FormCreate(Sender: TObject);
begin
	// Translate the form
	theLanguageManager.TranslateForm(self);

	// Set default captions
	lblOutputDirectory.Caption := '';
	lblOutputFileName.Caption := '';
end;

//--------------------------------------------------------------------------
// Public methods
//--------------------------------------------------------------------------

// Execute the form
//
procedure TFrmGuitarPracticeProgress.Execute(maxProgress: integer);
begin
	// Setup progress bar
	barProgress.Position := 0;
	barProgress.Min := 0;
	barProgress.Max := maxProgress;     

	// Show the form
	Show;
end;

//--------------------------------------------------------------------------
// Private methods
//--------------------------------------------------------------------------

//--------------------------------------------------------------------------
// Property methods
//--------------------------------------------------------------------------

// Get the output filename
//
function TFrmGuitarPracticeProgress.getOutputFileName: string;
begin
	result := lblOutputFileName.Caption;
end;

// Get the output filename
//
procedure TFrmGuitarPracticeProgress.setOutputFileName(val: string);
begin
	lblOutputFileName.Caption := ExtractFileName(val);
end;

// Get the output directory
//
function TFrmGuitarPracticeProgress.getOutputDirectory: string;
begin
	result := lblOutputDirectory.Caption;
end;

// Get the output directory
//
procedure TFrmGuitarPracticeProgress.setOutputDirectory(val: string);
begin
	lblOutputDirectory.Caption := val;
end;

// Get the progress
//
function TFrmGuitarPracticeProgress.getProgress: integer;
begin
	result := barProgress.Position;
end;

// Set the progress
//
procedure TFrmGuitarPracticeProgress.setProgress(val: integer);
begin
	barProgress.Position := val;
end;

end.
